/////////////////////////////////////////////////////////
//Component Name: companyWF2021.es
//Date: 30th Janaury 2020
//Author: Jeff Richards
//Version tested under: 2021
//////////////////////////////////////////////////

/////////////////////////////////
//collect/initialize parameters//
/////////////////////////////////
var ConfirmConditions = Param('ConfirmConditions');
if (ConfirmConditions != 'on') {
    Valid = false;
    ErrorStr = "You have not confirmed acceptance of the disclaimer";
}

AddMessage("Installation of component started");


/*
Columns that have been added or updated
*/

AddColumn('Company','Comp_PrimaryUserId','31','(0)','true','false');
var EditsId15 = AddCustom_Edits('Company','Comp_PrimaryUserId','22','2','','0','','','','N','');
AddCustom_Data('Custom_Edits', 'ColP', 'ColP_ColPropsId','ColP_ColPropsId, ColP_DataType, ColP_DataSize', EditsId15+',"5","0"','1');
AddCustom_Data('Custom_Edits','ColP','ColP_ColPropsId','ColP_ColPropsId,ColP_TiedFields',EditsId15+',","','1');
AddCustom_Data('FieldSecurity', 'FdSe', 'FdSe_FldSecurId','FdSe_ColPropsId,FdSe_SecType,FdSe_RecordId,FdSe_Permissions',EditsId15+',0,0,5','1,2,3');

AddColumn('Company','Comp_Type','10','(40)','true','false');
var EditsId43 = AddCustom_Edits('Company','Comp_Type','21','0','','1','Comp_Type','','','N','');
AddCustom_Data('Custom_Edits', 'ColP', 'ColP_ColPropsId','ColP_ColPropsId, ColP_DataType, ColP_DataSize', EditsId43+',"4","40"','1');
AddCustom_Data('Custom_Edits','ColP','ColP_ColPropsId','ColP_ColPropsId,ColP_TiedFields',EditsId43+',","','1');
AddCustom_Data('FieldSecurity', 'FdSe', 'FdSe_FldSecurId','FdSe_ColPropsId,FdSe_SecType,FdSe_RecordId,FdSe_Permissions',EditsId43+',0,0,5','1,2,3');

AddColumn('Company','Comp_Status','10','(40)','true','false');
var EditsId46 = AddCustom_Edits('Company','Comp_Status','21','1','Active','0','Comp_Status','','','N','');
AddCustom_Data('Custom_Edits', 'ColP', 'ColP_ColPropsId','ColP_ColPropsId, ColP_DataType, ColP_DataSize', EditsId46+',"4","40"','1');
AddCustom_Data('Custom_Edits','ColP','ColP_ColPropsId','ColP_ColPropsId,ColP_TiedFields',EditsId46+',","','1');
AddCustom_Data('FieldSecurity', 'FdSe', 'FdSe_FldSecurId','FdSe_ColPropsId,FdSe_SecType,FdSe_RecordId,FdSe_Permissions',EditsId46+',0,0,5','1,2,3');

AddColumn('Company','comp_SLAID','31','(0)','true','false');
var EditsId802 = AddCustom_Edits('Company','comp_SLAID','21','0','','0','slanames','','','N','');
AddCustom_Data('Custom_Edits', 'ColP', 'ColP_ColPropsId','ColP_ColPropsId, ColP_DataType, ColP_DataSize', EditsId802+',"5","0"','1');
AddCustom_Data('Custom_Edits','ColP','ColP_ColPropsId','ColP_ColPropsId,ColP_TiedFields',EditsId802+',","','1');
AddCustom_Data('Custom_Edits','ColP','ColP_ColPropsId','ColP_ColPropsId,ColP_SSViewField',EditsId802+',","','1');
AddCustom_Data('FieldSecurity', 'FdSe', 'FdSe_FldSecurId','FdSe_ColPropsId,FdSe_SecType,FdSe_RecordId,FdSe_Permissions',EditsId802+',0,0,5','1,2,3');

/*
Screen Objects that have been added or updated
*/

ObjectName='CompanyBoxLong';
ObjectType='Screen';
EntityName='Company';
var CObjId193 = AddScreenObject();


/*
Fields on screens that have been added or updated
*/

DeleteCustom_ScreenObject('CompanyBoxLong','',1);

// Adding new screen CompanyBoxLong
EntryScreenName='CompanyBoxLong';
FieldName='comp_name';
Newline=true;
AddEntryScreenField();

FieldName='comp_type';
AddEntryScreenField();

FieldName='comp_slaid';
CreateScript='ReadOnly=true;';
AddEntryScreenField();

FieldName='comp_website';
AddEntryScreenField();

FieldName='comp_status';
Newline=true;
AddEntryScreenField();

FieldName='comp_sector';
AddEntryScreenField();

FieldName='comp_employees';
AddEntryScreenField();

FieldName='comp_revenue';
AddEntryScreenField();

FieldName='comp_source';
Newline=true;
AddEntryScreenField();

FieldName='comp_secterr';
OnChangeScript='if (typeof(pers_secterr) != \x27undefined\x27)\n\r\n\r{\n\r\n\rpers_secterr.value=comp_secterr.v'+
'alue;\n\r\n\r}';
AddEntryScreenField();

FieldName='comp_primaryuserid';
AddEntryScreenField();

FieldName='comp_mailrestriction';
AddEntryScreenField();

AddCustom_Data('Custom_SysParams','Parm','Parm_Id','Parm_Name,Parm_Value','"Workflowcompany","Y"','1');


/*
Translations that have been added or updated
*/

FamilyType='Tags';
Family='WorkflowRule';
Code='Change Account Manager';
Captions['US']='Change Account Manager';
AddCaption();

FamilyType='Tags';
Family='WorkflowRule';
Code='Change SLA';
Captions['US']='Change SLA';
AddCaption();

FamilyType='Tags';
Family='WorkflowRule';
Code='Change Status';
Captions['US']='Change Status';
AddCaption();

FamilyType='Tags';
Family='WorkflowRule';
Code='Change Type';
Captions['US']='Change Type';
AddCaption();

FamilyType='Tags';
Family='WorkflowRule';
Code='Set Account Manager';
Captions['US']='Set Account Manager';
AddCaption();

FamilyType='Tags';
Family='WorkflowRule';
Code='Set Status';
Captions['US']='Set Status';
AddCaption();

FamilyType='Tags';
Family='WorkflowRule';
Code='Set Type';
Captions['US']='Set Type';
AddCaption();

FamilyType='Tags';
Family='WorkflowState';
Code='In Progress';
Captions['US']='In Progress';
AddCaption();

/*

Workflows that have been added or updated

*/

var jWorkflowId = AddCustom_Data('Workflow','work','work_workflowid','work_description,work_enabled','"Company Workflow","Y"','1');
AddCustom_Data('WorkflowTransition','WkTr','WkTr_TransitionId','WkTr_WorkflowId,WkTr_Stateid, WkTr_RuleId, WkTr_NextStateId',jWorkflowId+',0,0,0','1');
AddCustom_Data('WorkflowTransition','WkTr','WkTr_TransitionId','WkTr_WorkflowId,WkTr_Deleted',jWorkflowId+',1','1');
var jRuleId0 = 0;
var jStateId = AddCustom_Data('WorkflowState','WkSt','WkSt_StateId','WkSt_WorkflowId,WkSt_Name,WkSt_Description,WkSt_IsEntryPoint',jWorkflowId+',"Start","","Y",','1,2');
var jNextStateId = 0;
AddCustom_Data('WorkflowTransition','WkTr','WkTr_TransitionId','WkTr_WorkflowId,WkTr_StateId,WkTr_NextStateId,WkTr_RuleId,WkTr_Condition,WkTr_Expanded',jWorkflowId+','+jStateId+','+jNextStateId+','+jRuleId0+',"","y","','1,2,3,4');
var jRuleId10183 = AddCustom_Data('WorkflowRules','WkRl','WkRl_RuleId','WkRl_WorkflowId,WkRl_Entity,WkRl_Caption,WkRl_RuleType,WkRl_Image,WkRl_Table,WkRl_WhereClause,WkRl_Channel,WkRl_CustomFile,WkRl_Order,WkRl_JavaScript,WkRl_Cloneable,WkRl_Enabled,WkRl_RunInterval,WkRl_DotNet,WkRl_CustomFunction',jWorkflowId+',"Company","Set Account Manager","Pre","forward.GIF","Company","","","",,"","Y","Y","","","",','1,3,4');
RunSQL('UPDATE WorkflowRules SET WkRl_ActionGroupId = ' + jRuleId10183 + ' WHERE WkRl_RuleId = ' + jRuleId10183 + ' AND WkRl_ActionGroupId IS NULL');
RunSQL('DELETE FROM WorkflowActions WHERE WkAc_ActionId IN (SELECT AcLi_ActionId FROM WorkflowActionLinks WHERE AcLi_ActionGroupId = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10183 + ' ))');
RunSQL('DELETE FROM WorkflowActionLinks WHERE AcLi_ActionGroupID = (SELECT WkRl_ActionGroupID FROM WorkflowRules WHERE WkRl_RuleID = ' + jRuleId10183 + ' )');
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"comm","","comm_action=ToDo,comm_subject=Contact #comp_name# to agree SLA.,comm_location=,com'+
'm_note=Contact #comp_name# to agree SLA.,comm_status=Pending,comm_priority=Normal,'+
'comm_secterr=,comm_private=,comm_createdby=,comm_createddate=,comm_percentcomplete'+
'=,comm_completedtime=,comm_organizer=1,comm_datetime=,cmli_comm_userid=1,comm_toda'+
'tetime=,comm_isalldayevent=,comm_taskreminder=on,comm_notifydelta=10080,comm_notif'+
'ytime=,comm_smsnotification=,comm_channelid=5,NewTaskTimeOffset=0,","hidden","","","","","","","SLAComm","","","","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10183 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"previous","comp_primaryuserid","","req","0","1","1","","","","ReadOnly = false;","","","1","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10183 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"execsql","","insert into notes (note_foreigntableid, note_foreignid, note_note, note_createdby,'+
' note_createddate)\n\rvalues (5, #comp_companyid#, \x27#user_displayname# changed Compa'+
'ny Assigned User to #comp_primaryuserid#\x27, #user_userid#,getdate());","","","","","Company","","","","","","","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10183 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jStateId = AddCustom_Data('WorkflowState','WkSt','WkSt_StateId','WkSt_WorkflowId,WkSt_Name,WkSt_Description,WkSt_IsEntryPoint',jWorkflowId+',"Start","","Y",','1,2');
var jNextStateId = AddCustom_Data('WorkflowState','WkSt','WkSt_StateId','WkSt_WorkflowId,WkSt_Name,WkSt_Description,WkSt_IsEntryPoint',jWorkflowId+',"In Progress","","",','1,2');
AddCustom_Data('WorkflowTransition','WkTr','WkTr_TransitionId','WkTr_WorkflowId,WkTr_StateId,WkTr_NextStateId,WkTr_RuleId,WkTr_Condition,WkTr_Expanded',jWorkflowId+','+jStateId+','+jNextStateId+','+jRuleId10183+',"","y","','1,2,3,4');
var jRuleId10184 = AddCustom_Data('WorkflowRules','WkRl','WkRl_RuleId','WkRl_WorkflowId,WkRl_Entity,WkRl_Caption,WkRl_RuleType,WkRl_Image,WkRl_Table,WkRl_WhereClause,WkRl_Channel,WkRl_CustomFile,WkRl_Order,WkRl_JavaScript,WkRl_Cloneable,WkRl_Enabled,WkRl_RunInterval,WkRl_DotNet,WkRl_CustomFunction',jWorkflowId+',"Company","Set Type","Pre","forward.GIF","Company","","","",,"","Y","Y","","","",','1,3,4');
RunSQL('UPDATE WorkflowRules SET WkRl_ActionGroupId = ' + jRuleId10184 + ' WHERE WkRl_RuleId = ' + jRuleId10184 + ' AND WkRl_ActionGroupId IS NULL');
RunSQL('DELETE FROM WorkflowActions WHERE WkAc_ActionId IN (SELECT AcLi_ActionId FROM WorkflowActionLinks WHERE AcLi_ActionGroupId = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10184 + ' ))');
RunSQL('DELETE FROM WorkflowActionLinks WHERE AcLi_ActionGroupID = (SELECT WkRl_ActionGroupID FROM WorkflowRules WHERE WkRl_RuleID = ' + jRuleId10184 + ' )');
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"comm","","comm_action=ToDo,comm_subject=Contact #comp_name# to agree SLA.,comm_location=,com'+
'm_note=Contact #comp_name# to agree SLA.,comm_status=Pending,comm_priority=Normal,'+
'comm_secterr=,comm_private=,comm_createdby=,comm_createddate=,comm_percentcomplete'+
'=,comm_completedtime=,comm_organizer=1,comm_datetime=,cmli_comm_userid=1,comm_toda'+
'tetime=,comm_isalldayevent=,comm_taskreminder=on,comm_notifydelta=10080,comm_notif'+
'ytime=,comm_smsnotification=,comm_channelid=5,NewTaskTimeOffset=0,","hidden","","","","","","","SLAComm","","","","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10184 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"previous","comp_type","","req","0","1","1","","","","ReadOnly = false;","","","1","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10184 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"execsql","","insert into notes (note_foreigntableid, note_foreignid, note_note, note_createdby,'+
' note_createddate)\n\rvalues (5, #comp_companyid#, \x27#user_displayname# changed Compa'+
'ny Type to #comp_type#\x27, #user_userid#,getdate());","","","","","Company","","","","","","","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10184 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jStateId = AddCustom_Data('WorkflowState','WkSt','WkSt_StateId','WkSt_WorkflowId,WkSt_Name,WkSt_Description,WkSt_IsEntryPoint',jWorkflowId+',"Start","","Y",','1,2');
var jNextStateId = AddCustom_Data('WorkflowState','WkSt','WkSt_StateId','WkSt_WorkflowId,WkSt_Name,WkSt_Description,WkSt_IsEntryPoint',jWorkflowId+',"In Progress","","",','1,2');
AddCustom_Data('WorkflowTransition','WkTr','WkTr_TransitionId','WkTr_WorkflowId,WkTr_StateId,WkTr_NextStateId,WkTr_RuleId,WkTr_Condition,WkTr_Expanded',jWorkflowId+','+jStateId+','+jNextStateId+','+jRuleId10184+',"","y","','1,2,3,4');
var jRuleId10185 = AddCustom_Data('WorkflowRules','WkRl','WkRl_RuleId','WkRl_WorkflowId,WkRl_Entity,WkRl_Caption,WkRl_RuleType,WkRl_Image,WkRl_Table,WkRl_WhereClause,WkRl_Channel,WkRl_CustomFile,WkRl_Order,WkRl_JavaScript,WkRl_Cloneable,WkRl_Enabled,WkRl_RunInterval,WkRl_DotNet,WkRl_CustomFunction',jWorkflowId+',"Company","Set Status","Pre","forward.GIF","Company","","","",,"","Y","Y","","","",','1,3,4');
RunSQL('UPDATE WorkflowRules SET WkRl_ActionGroupId = ' + jRuleId10185 + ' WHERE WkRl_RuleId = ' + jRuleId10185 + ' AND WkRl_ActionGroupId IS NULL');
RunSQL('DELETE FROM WorkflowActions WHERE WkAc_ActionId IN (SELECT AcLi_ActionId FROM WorkflowActionLinks WHERE AcLi_ActionGroupId = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10185 + ' ))');
RunSQL('DELETE FROM WorkflowActionLinks WHERE AcLi_ActionGroupID = (SELECT WkRl_ActionGroupID FROM WorkflowRules WHERE WkRl_RuleID = ' + jRuleId10185 + ' )');
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"comm","","comm_action=ToDo,comm_subject=Contact #comp_name# to agree SLA.,comm_location=,com'+
'm_note=Contact #comp_name# to agree SLA.,comm_status=Pending,comm_priority=Normal,'+
'comm_secterr=,comm_private=,comm_createdby=,comm_createddate=,comm_percentcomplete'+
'=,comm_completedtime=,comm_organizer=1,comm_datetime=,cmli_comm_userid=1,comm_toda'+
'tetime=,comm_isalldayevent=,comm_taskreminder=on,comm_notifydelta=10080,comm_notif'+
'ytime=,comm_smsnotification=,comm_channelid=5,NewTaskTimeOffset=0,","hidden","","","","","","","SLAComm","","","","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10185 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"previous","comp_status","","req","0","1","1","","","","ReadOnly = false;","","","1","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10185 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"execsql","","insert into notes (note_foreigntableid, note_foreignid, note_note, note_createdby,'+
' note_createddate)\n\rvalues (5, #comp_companyid#, \x27#user_displayname# changed Compa'+
'ny Status to #comp_status#\x27, #user_userid#,getdate());","","","","","Company","","","","","","","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10185 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jStateId = AddCustom_Data('WorkflowState','WkSt','WkSt_StateId','WkSt_WorkflowId,WkSt_Name,WkSt_Description,WkSt_IsEntryPoint',jWorkflowId+',"Start","","Y",','1,2');
var jNextStateId = AddCustom_Data('WorkflowState','WkSt','WkSt_StateId','WkSt_WorkflowId,WkSt_Name,WkSt_Description,WkSt_IsEntryPoint',jWorkflowId+',"In Progress","","",','1,2');
AddCustom_Data('WorkflowTransition','WkTr','WkTr_TransitionId','WkTr_WorkflowId,WkTr_StateId,WkTr_NextStateId,WkTr_RuleId,WkTr_Condition,WkTr_Expanded',jWorkflowId+','+jStateId+','+jNextStateId+','+jRuleId10185+',"","y","','1,2,3,4');
var jRuleId10186 = AddCustom_Data('WorkflowRules','WkRl','WkRl_RuleId','WkRl_WorkflowId,WkRl_Entity,WkRl_Caption,WkRl_RuleType,WkRl_Image,WkRl_Table,WkRl_WhereClause,WkRl_Channel,WkRl_CustomFile,WkRl_Order,WkRl_JavaScript,WkRl_Cloneable,WkRl_Enabled,WkRl_RunInterval,WkRl_DotNet,WkRl_CustomFunction',jWorkflowId+',"Company","Change Account Manager","Pre","forward.GIF","Company","","","",,"","","Y","","","",','1,3,4');
RunSQL('UPDATE WorkflowRules SET WkRl_ActionGroupId = ' + jRuleId10186 + ' WHERE WkRl_RuleId = ' + jRuleId10186 + ' AND WkRl_ActionGroupId IS NULL');
RunSQL('DELETE FROM WorkflowActions WHERE WkAc_ActionId IN (SELECT AcLi_ActionId FROM WorkflowActionLinks WHERE AcLi_ActionGroupId = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10186 + ' ))');
RunSQL('DELETE FROM WorkflowActionLinks WHERE AcLi_ActionGroupID = (SELECT WkRl_ActionGroupID FROM WorkflowRules WHERE WkRl_RuleID = ' + jRuleId10186 + ' )');
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"previous","comp_primaryuserid","","req","0","1","1","","","","ReadOnly = false;","","","1","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10186 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"execsql","","insert into notes (note_foreigntableid, note_foreignid, note_note, note_createdby,'+
' note_createddate)\n\rvalues (5, #comp_companyid#, \x27#user_displayname# changed Compa'+
'ny Assigned User to #comp_primaryuserid#\x27, #user_userid#,getdate());","","","","","Company","","","","","","","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10186 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jStateId = AddCustom_Data('WorkflowState','WkSt','WkSt_StateId','WkSt_WorkflowId,WkSt_Name,WkSt_Description,WkSt_IsEntryPoint',jWorkflowId+',"In Progress","","",','1,2');
var jNextStateId = AddCustom_Data('WorkflowState','WkSt','WkSt_StateId','WkSt_WorkflowId,WkSt_Name,WkSt_Description,WkSt_IsEntryPoint',jWorkflowId+',"In Progress","","",','1,2');
AddCustom_Data('WorkflowTransition','WkTr','WkTr_TransitionId','WkTr_WorkflowId,WkTr_StateId,WkTr_NextStateId,WkTr_RuleId,WkTr_Condition,WkTr_Expanded',jWorkflowId+','+jStateId+','+jNextStateId+','+jRuleId10186+',"","y","','1,2,3,4');
var jRuleId10187 = AddCustom_Data('WorkflowRules','WkRl','WkRl_RuleId','WkRl_WorkflowId,WkRl_Entity,WkRl_Caption,WkRl_RuleType,WkRl_Image,WkRl_Table,WkRl_WhereClause,WkRl_Channel,WkRl_CustomFile,WkRl_Order,WkRl_JavaScript,WkRl_Cloneable,WkRl_Enabled,WkRl_RunInterval,WkRl_DotNet,WkRl_CustomFunction',jWorkflowId+',"Company","Change Type","Pre","forward.GIF","Company","","","",,"","","Y","","","",','1,3,4');
RunSQL('UPDATE WorkflowRules SET WkRl_ActionGroupId = ' + jRuleId10187 + ' WHERE WkRl_RuleId = ' + jRuleId10187 + ' AND WkRl_ActionGroupId IS NULL');
RunSQL('DELETE FROM WorkflowActions WHERE WkAc_ActionId IN (SELECT AcLi_ActionId FROM WorkflowActionLinks WHERE AcLi_ActionGroupId = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10187 + ' ))');
RunSQL('DELETE FROM WorkflowActionLinks WHERE AcLi_ActionGroupID = (SELECT WkRl_ActionGroupID FROM WorkflowRules WHERE WkRl_RuleID = ' + jRuleId10187 + ' )');
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"previous","comp_type","","req","0","1","1","","","","ReadOnly = false;","","","1","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10187 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"execsql","","insert into notes (note_foreigntableid, note_foreignid, note_note, note_createdby,'+
' note_createddate)\n\rvalues (5, #comp_companyid#, \x27#user_displayname# changed Compa'+
'ny Type to #comp_type#\x27, #user_userid#,getdate());","","","","","Company","","","","","","","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10187 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jStateId = AddCustom_Data('WorkflowState','WkSt','WkSt_StateId','WkSt_WorkflowId,WkSt_Name,WkSt_Description,WkSt_IsEntryPoint',jWorkflowId+',"In Progress","","",','1,2');
var jNextStateId = AddCustom_Data('WorkflowState','WkSt','WkSt_StateId','WkSt_WorkflowId,WkSt_Name,WkSt_Description,WkSt_IsEntryPoint',jWorkflowId+',"In Progress","","",','1,2');
AddCustom_Data('WorkflowTransition','WkTr','WkTr_TransitionId','WkTr_WorkflowId,WkTr_StateId,WkTr_NextStateId,WkTr_RuleId,WkTr_Condition,WkTr_Expanded',jWorkflowId+','+jStateId+','+jNextStateId+','+jRuleId10187+',"","y","','1,2,3,4');
var jRuleId10188 = AddCustom_Data('WorkflowRules','WkRl','WkRl_RuleId','WkRl_WorkflowId,WkRl_Entity,WkRl_Caption,WkRl_RuleType,WkRl_Image,WkRl_Table,WkRl_WhereClause,WkRl_Channel,WkRl_CustomFile,WkRl_Order,WkRl_JavaScript,WkRl_Cloneable,WkRl_Enabled,WkRl_RunInterval,WkRl_DotNet,WkRl_CustomFunction',jWorkflowId+',"Company","Change Status","Pre","forward.GIF","Company","","","",,"","","Y","","","",','1,3,4');
RunSQL('UPDATE WorkflowRules SET WkRl_ActionGroupId = ' + jRuleId10188 + ' WHERE WkRl_RuleId = ' + jRuleId10188 + ' AND WkRl_ActionGroupId IS NULL');
RunSQL('DELETE FROM WorkflowActions WHERE WkAc_ActionId IN (SELECT AcLi_ActionId FROM WorkflowActionLinks WHERE AcLi_ActionGroupId = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10188 + ' ))');
RunSQL('DELETE FROM WorkflowActionLinks WHERE AcLi_ActionGroupID = (SELECT WkRl_ActionGroupID FROM WorkflowRules WHERE WkRl_RuleID = ' + jRuleId10188 + ' )');
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"comm","","comm_action=ToDo,comm_subject=Company Status changed to #comp_status#.,comm_locati'+
'on=,comm_note=#user_firstname# #user_lastname# (#user_userid#) changed the company'+
' status  to #comp_status#.,comm_status=Complete,comm_priority=Normal,comm_secterr='+
',comm_private=,comm_createdby=,comm_createddate=,comm_percentcomplete=,comm_comple'+
'tedtime=,comm_organizer=1,comm_datetime=,cmli_comm_userid=1,comm_todatetime=,comm_'+
'isalldayevent=,comm_taskreminder=,comm_notifydelta=,comm_notifytime=,comm_smsnotif'+
'ication=,comm_channelid=5,NewTaskTimeOffset=,","hidden","","","","","","","","","","","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10188 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"previous","comp_status","","req","0","1","1","","","","ReadOnly = false;","","","1","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10188 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"execsql","","insert into notes (note_foreigntableid, note_foreignid, note_note, note_createdby,'+
' note_createddate)\n\rvalues (5, #comp_companyid#, \x27#user_displayname# changed Compa'+
'ny Status to #comp_status#\x27, #user_userid#,getdate());","","","","","","","","","","","","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10188 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jStateId = AddCustom_Data('WorkflowState','WkSt','WkSt_StateId','WkSt_WorkflowId,WkSt_Name,WkSt_Description,WkSt_IsEntryPoint',jWorkflowId+',"In Progress","","",','1,2');
var jNextStateId = AddCustom_Data('WorkflowState','WkSt','WkSt_StateId','WkSt_WorkflowId,WkSt_Name,WkSt_Description,WkSt_IsEntryPoint',jWorkflowId+',"In Progress","","",','1,2');
AddCustom_Data('WorkflowTransition','WkTr','WkTr_TransitionId','WkTr_WorkflowId,WkTr_StateId,WkTr_NextStateId,WkTr_RuleId,WkTr_Condition,WkTr_Expanded',jWorkflowId+','+jStateId+','+jNextStateId+','+jRuleId10188+',"","y","','1,2,3,4');
var jRuleId10189 = AddCustom_Data('WorkflowRules','WkRl','WkRl_RuleId','WkRl_WorkflowId,WkRl_Entity,WkRl_Caption,WkRl_RuleType,WkRl_Image,WkRl_Table,WkRl_WhereClause,WkRl_Channel,WkRl_CustomFile,WkRl_Order,WkRl_JavaScript,WkRl_Cloneable,WkRl_Enabled,WkRl_RunInterval,WkRl_DotNet,WkRl_CustomFunction',jWorkflowId+',"Company","Change SLA","Pre","forward.GIF","Company","","","",,"if (SLAComm.comm_status != \x27Complete\x27){Valid = false;}else{Valid = true;}","","Y","","","",','1,3,4');
RunSQL('UPDATE WorkflowRules SET WkRl_ActionGroupId = ' + jRuleId10189 + ' WHERE WkRl_RuleId = ' + jRuleId10189 + ' AND WkRl_ActionGroupId IS NULL');
RunSQL('DELETE FROM WorkflowActions WHERE WkAc_ActionId IN (SELECT AcLi_ActionId FROM WorkflowActionLinks WHERE AcLi_ActionGroupId = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10189 + ' ))');
RunSQL('DELETE FROM WorkflowActionLinks WHERE AcLi_ActionGroupID = (SELECT WkRl_ActionGroupID FROM WorkflowRules WHERE WkRl_RuleID = ' + jRuleId10189 + ' )');
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"comm","","comm_action=ToDo,comm_subject=SLA Changed to #comp_SLAID#.,comm_location=,comm_not'+
'e=#user_firstname# #user_lastname# (#user_userid#) changed the SLA to #comp_SLAID#'+
'.,comm_status=Complete,comm_priority=Normal,comm_secterr=,comm_private=,comm_creat'+
'edby=,comm_createddate=,comm_percentcomplete=,comm_completedtime=,comm_organizer=1'+
',comm_datetime=,cmli_comm_userid=1,comm_todatetime=,comm_isalldayevent=,comm_taskr'+
'eminder=,comm_notifydelta=,comm_notifytime=,comm_smsnotification=,comm_channelid=5'+
',NewTaskTimeOffset=,","hidden","","","","","","","","","","","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10189 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"previous","comp_slaid","","req","0","1","1","","","","ReadOnly = false;","","","1","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10189 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jActionId = AddCustom_Data('WorkflowActions','WkAc','WkAc_ActionId','WkAc_Action,WkAc_Field,WkAc_Value,WkAc_Attributes,WkAc_NewLine,WkAc_RowSpan,WkAc_ColSpan,WkAc_Table,WkAc_EmailTo,WkAc_EmailCC,WkAc_EmailBCC,WkAc_EmailSubject,WkAc_EmailBody,WkAc_Order,WkAc_Condition','"execsql","","insert into notes (note_foreigntableid, note_foreignid, note_note, note_createdby,'+
' note_createddate)\n\rvalues (5, #comp_companyid#, \x27#user_displayname# changed Compa'+
'ny SLA to #comp_slaid#\x27, #user_userid#,getdate());","","","","","Company","","","","","","","",','');
var LinkId = AddCustom_Data('WorkflowActionLinks','AcLi','AcLi_ActionLinkId','AcLi_ActionGroupId,AcLi_ActionId',-1+','+jActionId+',','');
RunSQL('UPDATE WorkflowActionLinks SET AcLi_ActionGroupID = (SELECT WkRl_ActionGroupId FROM WorkflowRules WHERE WkRl_RuleId = ' + jRuleId10189 + ') WHERE AcLi_ActionLinkId = ' +  LinkId);
var jStateId = AddCustom_Data('WorkflowState','WkSt','WkSt_StateId','WkSt_WorkflowId,WkSt_Name,WkSt_Description,WkSt_IsEntryPoint',jWorkflowId+',"In Progress","","",','1,2');
var jNextStateId = AddCustom_Data('WorkflowState','WkSt','WkSt_StateId','WkSt_WorkflowId,WkSt_Name,WkSt_Description,WkSt_IsEntryPoint',jWorkflowId+',"In Progress","","",','1,2');
AddCustom_Data('WorkflowTransition','WkTr','WkTr_TransitionId','WkTr_WorkflowId,WkTr_StateId,WkTr_NextStateId,WkTr_RuleId,WkTr_Condition,WkTr_Expanded',jWorkflowId+','+jStateId+','+jNextStateId+','+jRuleId10189+',"","y","','1,2,3,4');
